package com.xebulon.sherlock;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;


/**
 * This is a demo servlet demonstrating the use of the Sherlock
 * Inspector within a servlet. 
 *
 * This servlet displays the data that was posted via the
 * sherlockDemo.jsp page.
 */
public class SherlockDemoServlet extends HttpServlet {

    private String lastName = null;
    private String firstName = null;
    private String streetNumber = null;
    private String streetName = null;
    private String city = null;
    private String state = null;
    private String zip = null;
    private String appAttrName = null;
    private String appAttrValue = null;
    private String sessionAttrName = null;
    private String sessionAttrValue = null;


    public void doPost(HttpServletRequest request, HttpServletResponse response)
                        throws ServletException, IOException {

        doGet(request, response);
    }

    public void doGet(HttpServletRequest request, HttpServletResponse response)
                        throws ServletException, IOException {

        lastName = request.getParameter("lastName");
        firstName = request.getParameter("firstName");
        streetNumber = request.getParameter("streetNumber");
        streetName = request.getParameter("streetName");
        city = request.getParameter("city");
        state = request.getParameter("state");
        zip = request.getParameter("zipCode");
        appAttrName = request.getParameter("appAttrName");
        appAttrValue = request.getParameter("appAttrValue");
        sessionAttrName = request.getParameter("sessionAttrName");
        sessionAttrValue = request.getParameter("sessionAttrValue");

        getServletContext().setAttribute(appAttrName, appAttrValue);
        request.getSession().setAttribute(sessionAttrName, sessionAttrValue);

        PrintWriter out = response.getWriter();

        response.setContentType("text/html");

        String docType = "<!DOCTYPE HTMP PUBLIC \"-//W3C//DTD HTML 4.0 " +
                         "Transitional//EN\">\n";

        /*
         * Here is where we instantiate a new Sherlock object, passing it
         * references to the servlet context, session, and request scopes.
         */
        Sherlock sherlock = new Sherlock(getServletContext(), 
                                            request.getSession(), 
                                            request);

        out.println(docType +
                    "<html>\n" +
                    "<head><title>Sherlock Servlet Inspector Demo</title></head>\n" +
                    "<body bgcolor=\"#ffffff\">\n");

        out.println(createStylesheet());

        out.println("<div align='center'>\n");
        out.println("<h3>Sherlock<br>Servlet Inspector Demo</h3>\n");
        out.println("<table border='0'>\n");

        out.println("<tr><td>&nbsp;</td></tr>\n");
        out.println("<tr><td align='center'>");

        out.println("<table border='0' cellspacing='0' cellpadding='0' bgcolor='#656587' width='100%'>\n");
        out.println("<tr><td>");
        out.println("<table border='0' cellspacing='1' cellpadding='2' width='100%' bgcolor='#386427'>\n");
        out.println("<tr bgcolor='#778899'><td colspan='2' align='left' class='highlight' width='100%'>");
        out.println("<b>Click on \"REQUEST\" to view the following parameters:&nbsp</b>");
        out.println("</td></tr>\n");

        out.println("<tr bgcolor='#a9a9a9'>");
        out.println("<td class='small'>Parameter Name</td><td class='small' align='left'>Value</td>");
        out.println("</tr>\n");
        out.println("<tr bgcolor='#dcdcdc'><td class='small'>firstName</td><td class='small'>" + firstName + "</td></tr>\n");
        out.println("<tr bgcolor='#dcdcdc'><td class='small'>lastName</td><td class='small'>" + lastName + "</td></tr>\n");
        out.println("<tr bgcolor='#dcdcdc'><td class='small'>streetNumber</td><td class='small'>" + streetNumber + "</td></tr>\n");
        out.println("<tr bgcolor='#dcdcdc'><td class='small'>streetName</td><td class='small'>" + streetName + "</td></tr>\n");
        out.println("<tr bgcolor='#dcdcdc'><td class='small'>city</td><td class='small'>" + city + "</td></tr>\n");
        out.println("<tr bgcolor='#dcdcdc'><td class='small'>state</td><td class='small'>" + state + "</td></tr>\n");
        out.println("<tr bgcolor='#dcdcdc'><td class='small'>zipCode</td><td class='small'>" + zip + "</td></tr>\n");
        out.println("<tr bgcolor='#dcdcdc'><td class='small'>appAttrName</td><td class='small'>" + appAttrName + "</td></tr>\n");
        out.println("<tr bgcolor='#dcdcdc'><td class='small'>appAttrValue</td><td class='small'>" + appAttrValue + "</td></tr>\n");
        out.println("<tr bgcolor='#dcdcdc'><td class='small'>sessionAttrName</td><td class='small'>" + sessionAttrName + "</td></tr>\n");
        out.println("<tr bgcolor='#dcdcdc'><td class='small'>sessionAttrValue</td><td class='small'>" + sessionAttrValue + "</td></tr>\n");
        out.println("</table></td></tr></table>\n");

        out.println("</td></tr>\n");
        out.println("<tr><td>&nbsp;</td></tr>\n");
        out.println("<tr><td align='center'>");

        out.println("<table border='0' cellspacing='0' cellpadding='0' bgcolor='#386427' width='100%'>\n");
        out.println("<tr><td>");
        out.println("<table border='0' cellspacing='1' cellpadding='2' width='100%' bgcolor='#386427'>\n");
        out.println("<tr bgcolor='#778899'><td colspan='2' align='left' class='highlight' width='100%'>");
        out.println("<b>Click on \"APPLICATION\" to view the following attribute:&nbsp</b>");
        out.println("</td></tr>\n");

        out.println("<tr bgcolor='#a9a9a9'>");
        out.println("<td class='small'>Attribute Name</td><td class='small' align='left'>Value</td>");
        out.println("</tr>\n");
        out.println("<tr bgcolor='#dcdcdc'><td class='small'>" + appAttrName + "</td><td class='small'>" + appAttrValue + "</td></tr>\n");
        out.println("</table></td></tr></table>\n");

        out.println("</td></tr>\n");
        out.println("<tr><td>&nbsp;</td></tr>\n");
        out.println("<tr><td align='center'>");

        out.println("<table border='0' cellspacing='0' cellpadding='0' bgcolor='#386427' width='100%'>\n");
        out.println("<tr><td>");
        out.println("<table border='0' cellspacing='1' cellpadding='2' width='100%' bgcolor='#386427'>\n");
        out.println("<tr bgcolor='#778899'><td colspan='2' align='left' class='highlight' width='100%'>");
        out.println("<b>Click on \"SESSION\" to view the following attribute:&nbsp;</b>");
        out.println("</td></tr>\n");

        out.println("<tr bgcolor='#a9a9a9'>");
        out.println("<td class='small'>Attribute Name</td><td class='small' align='left'>Value</td>");
        out.println("</tr>\n");
        out.println("<tr bgcolor='#dcdcdc'><td class='small'>" + sessionAttrName + "</td><td class='small'>" + sessionAttrValue + "</td></tr>\n");
        out.println("</table></td></tr></table>\n");


        out.println("</td></tr>\n");
        out.println("<tr><td>&nbsp;</td></tr>\n");
                    
        out.println("<tr><td width='100%'><table border='0' width='100%'>");
        out.println("<tr>");
        out.println("<td>");
        /*
         * Here is where we call the getLink() method of the Sherlock class. This method
         * will return an anchor <a> tag specifying a link to the Sherlock Inspector servlet.
         */
        out.println(sherlock.getLink());

        out.println("</td>");
        out.println("<td>&nbsp;</td>");
        out.println("<td class='small'>Click on the image at the left to display the Sherlock Inspector window.</td>");
        out.println("</tr></table></td></tr>");
                    
        out.println("</table>");

        out.println("</div>\n");

        out.println("</body></html>\n");
    }

    private String createStylesheet() {

        StringBuffer out = new StringBuffer("");

        out.append("<style type='text/css'>\n");
        out.append("<!--\n");
        out.append(".small {font-size:10pt;font-family:arial,sans-serif;font-weight:normal;font-style:normal;text-indent:0px;line-height:15px;}\n");
        out.append(".highlight {color:#ffffff;font-size:10pt;font-family:arial,sans-serif;font-weight:normal;font-style:normal;text-indent:0px;line-height:15px;}-->\n");

        out.append("</style>\n");

        return(out.toString());
    }
}
